#ifndef CALCXX_DRIVER_HH
#define CALCXX_DRIVER_HH
#include <string>
#include <map>
using namespace std;
// Forward declarations.
union YYSTYPE;
namespace yy
{
  class location;
  class calcxx_parser;
}
class calcxx_driver;
// Announce to Flex the prototype we want for lexing function, ...
#define YY_DECL						 \
       int yylex (YYSTYPE* yylval, yy::location* yylloc, calcxx_driver& driver)
// ... and declare it for the parser's sake.
YY_DECL;
// Conducting the whole scanning and parsing of Calc++.
class calcxx_driver
{
public:
  calcxx_driver ();
  virtual ~calcxx_driver ();

  std::map<std::string, int> variables;

  int result;

  // Handling the scanner.
  void scan_begin ();
  void scan_end ();
  bool trace_scanning;

  //Similarly for the parser itself.

  // Handling the parser.
  void parse (const std::string& f);
  std::string file;
  bool trace_parsing;
  // Error handling.
  void error (const yy::location& l, const std::string& m);
  void error (const std::string& m);
};
#endif // ! CALCXX_DRIVER_HH

