%skeleton "lalr1.cc"                          /*  -*- C++ -*- */
%define "parser_class_name" "calcxx_parser"
%defines
%{
#include <iostream>
#include <string>
#include "calc++-driver.hh"
using namespace std;
%}
// The parsing context.
%parse-param { calcxx_driver& driver }
%lex-param   { calcxx_driver& driver }
%locations
%initial-action
{
  // Initialize the initial location.
  @$.begin.filename = @$.end.filename = &driver.file;
};
%debug
%error-verbose
// Symbols.
%union
{
  int          ival;
};
%token        TOKEN_EOF      0 "end of file"
%token <ival> TOKEN_NUMBER     "number"
%type  <ival> exp              "expression"
%printer    { debug_stream () << $$; } "number" "expression"
%%
%start input;
input:
| input line {};
line: '\n' { cout << 0 << endl ; };
| exp '\n' { cout << $1 << endl ; };

%left '+' '-';
%left '*' '/';
exp: exp '+' exp   { $$ = $1 + $3; }
   | exp '-' exp   { $$ = $1 - $3; }
   | exp '*' exp   { $$ = $1 * $3; }
   | exp '/' exp   { $$ = $1 / $3; }
   | TOKEN_NUMBER      { $$ = $1; };
%%
void
yy::calcxx_parser::error (const yy::calcxx_parser::location_type& l,
                          const std::string& m)
{
  driver.error (l, m);
}

